from gtcdata.loader import gtcData3d
from gtcdata.visualizer import Data3dVisualizer as d3v
import matplotlib.pyplot as plt
import numpy as np
import tkinter as tk


def data3d_window(selfi, path, file_type):

    if file_type==0:
        filename = path+"/phi_3d.bp"
    elif file_type==1:
        filename = path+"/phi_3d.out"

        filename = tk.filedialog.askopenfilename( initialdir=path, title="Select data_3d", filetypes=( ("Old data3d format", "*.out"), ("all files", "*.*") ) )
        print('filename_asked = ',filename)
        if not filename:
            return



    data3ddata = gtcData3d(filename, verbose=True)

    myD3V = d3v(data3ddata,selfi)
    # test lines:
    # print(myD3V._data_file)
    # print(data3ddata.mpsi)
    # print(data3ddata.mpsi.shape)
    # print(data3ddata.profile.shape)
    # print(data3ddata.nstep)

    ## functions for GUI

    ## GUI for plots

    window = tk.Toplevel(selfi)
    #window = tk.Tk()
    #window.pack_propagate(0) #prevent the window from shrinking
    window.title("Data3d panel at timestep #" + str(myD3V._realnstep))
    #window.geometry('500x300')

    # Plot 1
    #lbl1 = tk.Label(window, text="Catagory 1", height=1, width=13)
    #lbl1.grid(column=0, row=0)
    def clicked1():
        myD3V.gene_out()
    btn1 = tk.Button(window, text="gen *.out", command=clicked1, height=1, width=10)
    btn1.grid(column=1, row=1)

    # Plot 2
    #lbl1 = tk.Label(window, text="Catagory 1", height=1, width=13)
    #lbl1.grid(column=0, row=0)
    def clicked2():
        myD3V.gene_silo()
    btn1 = tk.Button(window, text="gen *.silo", command=clicked2, height=1, width=10)
    btn1.grid(column=2, row=1)

    #######################################

    #change the time step for the data3d
    var_nstep = tk.StringVar()
    var_nstep.set(myD3V._realnstep)
    txtnstep = tk.Entry(window,width=10,textvariable=var_nstep,state="disabled")
    txtnstep.grid(column=8, row=1)

    def clicked_nstep():
        time_count = int(len(myD3V._data.step_id))
        #print('time_count =',time_count)
        #time_count = myD3V._data.mpsi.shape[0]
        #print(myD3V._data.mpsi.shape)
        #test lines:
        #steplist = np.linspace(0,(time_count-1)*100,time_count)
        steplist = myD3V._data.step_id

        wd_nstep = tk.Toplevel(window)
        lbl_nlist = tk.Label(wd_nstep, text="Data3d at available timesteps:", height=1)
        lbl_nlist.grid(sticky="w", pady=4, padx=5)

        nstep_bar = tk.Scrollbar(wd_nstep) 
        nstep_bar.grid(row=1, column=2, rowspan=4, sticky="ewsn")
        nstep_list = tk.Listbox(wd_nstep, yscrollcommand = nstep_bar.set ) 
        for line in range(time_count): 
            nstep_list.insert("end", str(line).zfill(3) + '. Data3d #' + str(int(steplist[line])).zfill(7)) 
        nstep_list.grid(row=1, column=0, columnspan=2, rowspan=4, padx=2, sticky="ewsn")
        nstep_bar.config( command = nstep_list.yview )

        def clicked():
            n_active = str(nstep_list.get("active"))
            #print(n_active)
            #print(n_active[-7:])
            myD3V._realnstep = int(n_active[-7:])
            myD3V._nstep = int(n_active[:3])
            #print('myD3V._realstep=',myD3V._realnstep)
            #print('myD3V._nstep=',myD3V._nstep)
            wd_nstep.destroy()
            var_nstep.set(myD3V._realnstep)
            window.title("Data3d pannel at timestep #" + str(myD3V._realnstep))
        btn_nstep = tk.Button(wd_nstep, text="Confirm", command=clicked, height=1, width=10)
        btn_nstep.grid(row=5, column=0, padx=4, sticky="w")

        btn_wd_quit = tk.Button(wd_nstep, text="Quit", fg="red",
                                command=wd_nstep.destroy, height=1, width=10)
        btn_wd_quit.grid(row=5, column=0, padx=104, sticky="w")
        wd_nstep.mainloop()

    def clicked_nstep_old():        
        wd_nstep = tk.Toplevel(window)
        txt_nstep = tk.Entry(wd_nstep,width=10)
        txt_nstep.grid(column=2,row=1)
        def clicked():
            myD3V._nstep = int(txt_nstep.get())
            wd_nstep.destroy()
            var_nstep.set(myD3V._nstep)
            window.title("Data3d pannel at timestep #" + str(myD3V._nstep))
        btn_nstep = tk.Button(wd_nstep, text="Confirm", command=clicked, height=1, width=10)
        btn_nstep.grid(column=3,row=1)
        wd_nstep.mainloop()

    btn_edit = tk.Button(window, text="timestep", command=clicked_nstep, height=1, width=10)
    btn_edit.grid(column=7, row=1)

#    #change the mode range
#    var_mmode = tk.StringVar()
#    txt_mmode = tk.Entry(window,width=10,textvariable=var_mmode)
#    txt_mmode.grid(column=8, row=2)
#    var_mmode.set(myD3V.mmode)
#    var_pmode = tk.StringVar()
#    txt_pmode = tk.Entry(window,width=10,textvariable=var_pmode)
#    txt_pmode.grid(column=9, row=2)
#    var_pmode.set(myD3V.pmode)
#    def clicked_mdrange():
#        if var_mmode.get()=="" or var_pmode.get()=="":
#            var_mmode.set(myD3V.mmode)
#            var_pmode.set(myD3V.pmode)
#        else:
#            myD3V.mmode = int(var_mmode.get())
#            myD3V.pmode = int(var_pmode.get())
#    btn_edit = tk.Button(window, text="mode# range", command=clicked_mdrange, height=1, width=10)
#    btn_edit.grid(column=7, row=2)
#
#    lb_mrange = tk.Label(window, text = "( m, n )_max: ("+ str( myD3V._data.mtgrid ) +', '+ str( myD3V._data.mtoroidal ) +')')
#    lb_mrange.grid(column = 10, row = 2)
#
#    #change the cutoff value for the flux range
#    var_cutoff = tk.StringVar()
#    txt_cutoff = tk.Entry(window,width=10,textvariable=var_cutoff)
#    txt_cutoff.grid(column=8, row=3)
#    var_cutoff.set(myD3V.cutoff)
#    def clicked_cutoff():
#        if var_cutoff.get()=="":
#            var_cutoff.set(myD3V.cutoff)
#        else:
#            myD3V.cutoff = float(var_cutoff.get())
#            var_cutoff.set(myD3V.cutoff)
#    btn_edit = tk.Button(window, text="legend_cutoff", command=clicked_cutoff, height=1, width=10)
#    btn_edit.grid(column=7, row=3)
#
#    lb_cutoff = tk.Label(window, text = "("+ str(0.0) +', '+ str(myD3V.cutoff) +')')
#    lb_cutoff.grid(column = 9, row = 3)

    #select the method to refresh figures
    select_plt = tk.IntVar()
    select_plt.set(0)
    def click_slct():
        myD3V.plot_mode = int(select_plt.get())
        if myD3V.plot_mode == 1:
            print('plot mode changes to "New Figs"')
        elif myD3V.plot_mode == 0:
            print('plot mode changes to "Refresh"')
        else:
            print('error: wrong input for plot mode')
    rad1 = tk.Radiobutton(window,text='New Figs', value=1, 
                        variable=select_plt, command=click_slct, width=10)
    rad1.grid(column=7, row=5)
    rad2 = tk.Radiobutton(window,text='Refresh', value=0, 
                        variable=select_plt, command=click_slct, width=10)
    rad2.grid(column=8, row=5)

    #######################################

    # Button to reset all settings of the main window
    def click_reset():
#        myD3V.mmode = int(myD3V._data.mtgrid/5)
#        var_mmode.set(myD3V.mmode)
#        myD3V.pmode = int(myD3V._data.mtoroidal/5)
#        var_pmode.set(myD3V.pmode)
         
#        myD3V.cutoff = 1.0
#        var_cutoff.set(myD3V.cutoff)
        
        myD3V.plot_mode = 0
        select_plt.set(0)
    btn_reset = tk.Button(window, text="reset", fg="red", 
                          command=click_reset, height=1, width=10)
    btn_reset.grid(column=12, row=13)

    # Button to quit the main window
    btn_quit = tk.Button(window, text="Quit", fg="red", 
                        command=window.destroy, height=1, width=10)
    btn_quit.grid(column=13, row=13)

    window.mainloop()

    ## test functions

    #myEV.print_test()
    #input("press Enter...")

    #plt.show(block=False)
    #input("press Enter to close plots")

