import tkinter as tk

import snapshot_plot as sp
import data1d_plot as dp
import history_plot as hp
import equilibrium_plot as ep
import data3d_plot as d3p

class MainWindow(tk.Frame):
    counter = 0
    def __init__(self, *args, **kwargs):

        self.path = "./"  #"/home/wwang/adios_dir/test_data/"
        self.file_type = 0

        tk.Frame.__init__(self, *args, **kwargs)
    #    self.button = tk.Button(self, text="Create new window", 
    #                            command=self.create_window)
    #    self.button.pack(side="top")


        ### select the file type to plot figures
        lb_ftype = tk.Label(self, text = "Select file type: ")
        lb_ftype.grid(column = 1, row = 1, columnspan = 2, rowspan = 1)

       
        select_ftype = tk.IntVar()
        select_ftype.set(0)
        def click_ftype_slct():
            self.file_type = int(select_ftype.get())
            if self.file_type == 1:
                print('\n\n\nfile type changes to OLD OUTPUT:  *.out\n')
            elif self.file_type == 0:
                print('\n\n\nfile type changes to ADIOS2:  *.bp\n')
            else:
                print('error: wrong input for file type')
        rad1 = tk.Radiobutton(self,text='.out', value=1, 
                              variable=select_ftype, 
                              command=click_ftype_slct, width=10)
        rad1.grid(column=3, row=1)
        rad2 = tk.Radiobutton(self,text='.bp', value=0, 
                              variable=select_ftype, 
                              command=click_ftype_slct, width=10)
        rad2.grid(column=4, row=1)


        ### buttons for different panels for each file

        self.btn1 = tk.Button(self, text="History", command=self.create_histo_window, height=1, width=10)
        self.btn1.grid(column=1, row=2)

        self.btn2 = tk.Button(self, text="Equilibrium", command=self.create_eq_window, height=1, width=10)
        self.btn2.grid(column=2, row=2)

        self.btn3 = tk.Button(self, text="Snapshot", command=self.create_snap_window, height=1, width=10)
        self.btn3.grid(column=3, row=2)

        self.btn4= tk.Button(self, text="Data1d", command=self.create_data1d_window, height=1, width=10)
        self.btn4.grid(column=4, row=2)

        self.btn5 = tk.Button(self, text="Data3d", command=self.create_data3d_window, height=1, width=10)
        self.btn5.grid(column=5, row=2)


#######################################

    #def create_window(self):
    #    self.counter += 1
    #    #window = tk.Toplevel(self)
    #    sp.snap_window(self, self.path)
    #
    #    #t.wm_title("Window #%s" % self.counter)
    #    #l = tk.Label(t, text="This is window #%s" % self.counter)
    #    #l.pack(side="top", fill="both", expand=True, padx=100, pady=100)

    def create_snap_window(self):
        self.counter += 1
        #window = tk.Toplevel(self)
        sp.snap_window(self, self.path, self.file_type)

    def create_data1d_window(self):
        self.counter += 1
        #window = tk.Toplevel(self)
        dp.data1d_window(self, self.path, self.file_type)

    def create_histo_window(self):
        self.counter += 1
        #window = tk.Toplevel(self)
        hp.histo_window(self, self.path, self.file_type)

    def create_eq_window(self):
        self.counter += 1
        #window = tk.Toplevel(self)
        ep.eq_window(self, self.path, self.file_type)

    def create_data3d_window(self):
        self.counter += 1
        #window = tk.Toplevel(self)
        d3p.data3d_window(self, self.path, self.file_type)

#######################################

#if __name__ == "__main__":
root = tk.Tk()
root.title("Adipy ver1.0 -- GTC plot package")

main = MainWindow(root)
main.pack(side="top", fill="both", expand=True)

# Button to quit the main window
btn_quit = tk.Button(root, text="Quit", fg="red", 
                    command=root.destroy, height=1, width=10)
btn_quit.pack(side="top", fill="both", expand=True)

import os
cwd = os.getcwd()
print(cwd)
main.path = cwd

root.mainloop()
