from gtcdata.loader import gtcSnapshot
from gtcdata.visualizer import SnapshotVisualizer as sv
import matplotlib.pyplot as plt
import numpy as np
import tkinter as tk


def snap_window(selfi, path, file_type):

    if file_type==0:
        filename = path+"/snapshot.bp"
    elif file_type==1:
        filename = path+"/snap0000000.out"

        filename = tk.filedialog.askopenfilename( initialdir=path, title="Select snapshot", filetypes=( ("Old snap format", "*.out"), ("all files", "*.*") ) )
        print('filename_asked = ',filename)
        if not filename:
            return



    snapdata = gtcSnapshot(filename, verbose=True)

    mySV = sv(snapdata,selfi)
    # test lines:
    # print(mySV._data_file)
    # print(snapdata.mpsi)
    # print(snapdata.mpsi.shape)
    # print(snapdata.profile.shape)
    # print(snapdata.nstep)

    ## functions for GUI

    ## GUI for plots

    window = tk.Toplevel(selfi)
    #window = tk.Tk()
    #window.pack_propagate(0) #prevent the window from shrinking
    window.title("Snapshot panel at timestep #" + str(mySV._realnstep))
    #window.geometry('500x300')

    # Plot 1
    #lbl1 = tk.Label(window, text="Catagory 1", height=1, width=13)
    #lbl1.grid(column=0, row=0)
    def clicked1():
        mySV.plot_ion_rho()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="ion density", command=clicked1, height=1, width=10)
    btn1.grid(column=1, row=1)

    # Plot 2
    #lbl2 = tk.Label(window, text="Catagory 2", height=1, width=13)
    #lbl2.grid(column=0, row=1)
    def clicked2():
        mySV.plot_flow_1()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="flow", command=clicked2, height=1, width=10)#, state='disabled')
    btn1.grid(column=1, row=2)
    
    ####
    def clicked3():
        mySV.plot_energy_1()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="energy", command=clicked3, height=1, width=10)
    btn1.grid(column=1, row=3)

    ####
    def clicked4():
        mySV.plot_pdf_energy_1()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="PDF-energy", command=clicked4, height=1, width=10)
    btn1.grid(column=1, row=4)

    #####
    def clicked5():
        mySV.plot_pdf_pitch_angle_1()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="PDF-pitch", command=clicked5, height=1, width=10)
    btn1.grid(column=1, row=5)

    ####
    def clicked6():
        mySV.plot_electron_rho()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="electron density", command=clicked6, height=1, width=10)
    btn1.grid(column=2, row=1)

    ####
    def clicked7():
        mySV.plot_flow_2()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="flow", command=clicked7, height=1, width=10)#, state='disabled')
    btn1.grid(column=2, row=2)
    
    ####
    def clicked8():
        mySV.plot_energy_2()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="energy", command=clicked8, height=1, width=10)
    btn1.grid(column=2, row=3)

    ####
    def clicked9():
        mySV.plot_pdf_energy_2()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="PDF-energy", command=clicked9, height=1, width=10)
    btn1.grid(column=2, row=4)

    #####
    def clicked10():
        mySV.plot_pdf_pitch_angle_2()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="PDF-pitch", command=clicked10, height=1, width=10)
    btn1.grid(column=2, row=5)

    ####
    def clicked11():
        mySV.plot_ep_rho()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="ep density", command=clicked11, height=1, width=10)
    btn1.grid(column=3, row=1)

    ####
    def clicked12():
        mySV.plot_flow_3()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="flow", command=clicked12, height=1, width=10)#, state='disabled')
    btn1.grid(column=3, row=2)
    
    ####
    def clicked13():
        mySV.plot_energy_3()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="energy", command=clicked13, height=1, width=10)
    btn1.grid(column=3, row=3)

    ####
    def clicked14():
        mySV.plot_pdf_energy_3()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="PDF-energy", command=clicked14, height=1, width=10)
    btn1.grid(column=3, row=4)

    #####
    def clicked15():
        mySV.plot_pdf_pitch_angle_3()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="PDF-pitch", command=clicked15, height=1, width=10)
    btn1.grid(column=3, row=5)

    #####
    def clicked16():
        mySV.contour_phi_fluxsurf()
#        plt.show(block=False)
    btn2 = tk.Button(window, text="phi-flux", command=clicked16, height=1, width=10)
    btn2.grid(column=4, row=1)

    #####
    def clicked17():
        mySV.plot_spectrum_1()
#        plt.show(block=False)
    btn2 = tk.Button(window, text="spectrum", command=clicked17, height=1, width=10)
    btn2.grid(column=4, row=2)

    #####
    def clicked18():
        mySV.contour_poloidal_1()
#        plt.show(block=False)
    btn2 = tk.Button(window, text="poloidal", command=clicked18, height=1, width=10)
    btn2.grid(column=4, row=3)

    #####
    def clicked19():
        mySV.plot_radius_field_1()
#        plt.show(block=False)
    btn2 = tk.Button(window, text="psi", command=clicked19, height=1, width=10)
    btn2.grid(column=4, row=4)

    #####
    def clicked20():
        mySV.plot_poloidal_field_1()
#        plt.show(block=False)
    btn2 = tk.Button(window, text="theta", command=clicked20, height=1, width=10)
    btn2.grid(column=4, row=5)

    #####
    def clicked21():
        mySV.contour_apara_fluxsurf()
#        plt.show(block=False)
    btn2 = tk.Button(window, text="apara-flux", command=clicked21, height=1, width=10)
    btn2.grid(column=5, row=1)

    #####
    def clicked22():
        mySV.plot_spectrum_2()
#        plt.show(block=False)
    btn2 = tk.Button(window, text="spectrum", command=clicked22, height=1, width=10)
    btn2.grid(column=5, row=2)

    #####
    def clicked23():
        mySV.contour_poloidal_2()
#        plt.show(block=False)
    btn2 = tk.Button(window, text="poloidal", command=clicked23, height=1, width=10)
    btn2.grid(column=5, row=3)

    #####
    def clicked24():
        mySV.plot_radius_field_2()
#        plt.show(block=False)
    btn2 = tk.Button(window, text="psi", command=clicked24, height=1, width=10)
    btn2.grid(column=5, row=4)

    #####
    def clicked25():
        mySV.plot_poloidal_field_2()
#        plt.show(block=False)
    btn2 = tk.Button(window, text="theta", command=clicked25, height=1, width=10)
    btn2.grid(column=5, row=5)

    #####
    def clicked26():
        mySV.contour_fluidne_fluxsurf()
#        plt.show(block=False)
    btn2 = tk.Button(window, text="fluidne-flux", command=clicked26, height=1, width=10)
    btn2.grid(column=6, row=1)

    #####
    def clicked27():
        mySV.plot_spectrum_3()
#        plt.show(block=False)
    btn2 = tk.Button(window, text="spectrum", command=clicked27, height=1, width=10)
    btn2.grid(column=6, row=2)

    #####
    def clicked28():
        mySV.contour_poloidal_3()
#        plt.show(block=False)
    btn2 = tk.Button(window, text="poloidal", command=clicked28, height=1, width=10)
    btn2.grid(column=6, row=3)

    #####
    def clicked29():
        mySV.plot_radius_field_3()
#        plt.show(block=False)
    btn2 = tk.Button(window, text="psi", command=clicked29, height=1, width=10)
    btn2.grid(column=6, row=4)

    #####
    def clicked30():
        mySV.plot_poloidal_field_3()
#        plt.show(block=False)
    btn2 = tk.Button(window, text="theta", command=clicked30, height=1, width=10)
    btn2.grid(column=6, row=5)

    #######################################

    #change the time step for the snapshot
    var_nstep = tk.StringVar()
    var_nstep.set(mySV._realnstep)
    txtnstep = tk.Entry(window,width=10,textvariable=var_nstep,state="disabled")
    txtnstep.grid(column=8, row=1)

    def clicked_nstep():
        time_count = int(len(mySV._data.step_id))
        #print('time_count =',time_count)
        #time_count = mySV._data.mpsi.shape[0]
        #print(mySV._data.mpsi.shape)
        #test lines:
        #steplist = np.linspace(0,(time_count-1)*100,time_count)
        steplist = mySV._data.step_id

        wd_nstep = tk.Toplevel(window)
        lbl_nlist = tk.Label(wd_nstep, text="Snapshots at available timesteps:", height=1)
        lbl_nlist.grid(sticky="w", pady=4, padx=5)

        nstep_bar = tk.Scrollbar(wd_nstep) 
        nstep_bar.grid(row=1, column=2, rowspan=4, sticky="ewsn")
        nstep_list = tk.Listbox(wd_nstep, yscrollcommand = nstep_bar.set ) 
        for line in range(time_count): 
            nstep_list.insert("end", str(line).zfill(3) + '. Snapshot #' + str(int(steplist[line])).zfill(7)) 
        nstep_list.grid(row=1, column=0, columnspan=2, rowspan=4, padx=2, sticky="ewsn")
        nstep_bar.config( command = nstep_list.yview )

        def clicked():
            n_active = str(nstep_list.get("active"))
            #print(n_active)
            #print(n_active[-7:])
            mySV._realnstep = int(n_active[-7:])
            mySV._nstep = int(n_active[:3])
            #print('mySV._realstep=',mySV._realnstep)
            #print('mySV._nstep=',mySV._nstep)
            wd_nstep.destroy()
            var_nstep.set(mySV._realnstep)
            window.title("Snapshot pannel at timestep #" + str(mySV._realnstep))
        btn_nstep = tk.Button(wd_nstep, text="Confirm", command=clicked, height=1, width=10)
        btn_nstep.grid(row=5, column=0, padx=4, sticky="w")

        btn_wd_quit = tk.Button(wd_nstep, text="Quit", fg="red",
                                command=wd_nstep.destroy, height=1, width=10)
        btn_wd_quit.grid(row=5, column=0, padx=104, sticky="w")
        wd_nstep.mainloop()

    def clicked_nstep_old():        
        wd_nstep = tk.Toplevel(window)
        txt_nstep = tk.Entry(wd_nstep,width=10)
        txt_nstep.grid(column=2,row=1)
        def clicked():
            mySV._nstep = int(txt_nstep.get())
            wd_nstep.destroy()
            var_nstep.set(mySV._nstep)
            window.title("Snapshot pannel at timestep #" + str(mySV._nstep))
        btn_nstep = tk.Button(wd_nstep, text="Confirm", command=clicked, height=1, width=10)
        btn_nstep.grid(column=3,row=1)
        wd_nstep.mainloop()

    btn_edit = tk.Button(window, text="timestep", command=clicked_nstep, height=1, width=10)
    btn_edit.grid(column=7, row=1)

    #change the mode range
    var_mmode = tk.StringVar()
    txt_mmode = tk.Entry(window,width=10,textvariable=var_mmode)
    txt_mmode.grid(column=8, row=2)
    var_mmode.set(mySV.mmode)
    var_pmode = tk.StringVar()
    txt_pmode = tk.Entry(window,width=10,textvariable=var_pmode)
    txt_pmode.grid(column=9, row=2)
    var_pmode.set(mySV.pmode)
    def clicked_mdrange():
        if var_mmode.get()=="" or var_pmode.get()=="":
            var_mmode.set(mySV.mmode)
            var_pmode.set(mySV.pmode)
        else:
            mySV.mmode = int(var_mmode.get())
            mySV.pmode = int(var_pmode.get())
    btn_edit = tk.Button(window, text="mode# range", command=clicked_mdrange, height=1, width=10)
    btn_edit.grid(column=7, row=2)

    lb_mrange = tk.Label(window, text = "( m, n )_max: ("+ str( mySV._data.mtgrid ) +', '+ str( mySV._data.mtoroidal ) +')')
    lb_mrange.grid(column = 10, row = 2)

    #change the cutoff value for the flux range
    var_cutoff = tk.StringVar()
    txt_cutoff = tk.Entry(window,width=10,textvariable=var_cutoff)
    txt_cutoff.grid(column=8, row=3)
    var_cutoff.set(mySV.cutoff)
    def clicked_cutoff():
        if var_cutoff.get()=="":
            var_cutoff.set(mySV.cutoff)
        else:
            mySV.cutoff = float(var_cutoff.get())
            var_cutoff.set(mySV.cutoff)
    btn_edit = tk.Button(window, text="legend_cutoff", command=clicked_cutoff, height=1, width=10)
    btn_edit.grid(column=7, row=3)

    lb_cutoff = tk.Label(window, text = "("+ str(0.0) +', '+ str(mySV.cutoff) +')')
    lb_cutoff.grid(column = 9, row = 3)

    #select the method to refresh figures
    select_plt = tk.IntVar()
    select_plt.set(0)
    def click_slct():
        mySV.plot_mode = int(select_plt.get())
        if mySV.plot_mode == 1:
            print('plot mode changes to "New Figs"')
        elif mySV.plot_mode == 0:
            print('plot mode changes to "Refresh"')
        else:
            print('error: wrong input for plot mode')
    rad1 = tk.Radiobutton(window,text='New Figs', value=1, 
                        variable=select_plt, command=click_slct, width=10)
    rad1.grid(column=7, row=5)
    rad2 = tk.Radiobutton(window,text='Refresh', value=0, 
                        variable=select_plt, command=click_slct, width=10)
    rad2.grid(column=8, row=5)

    #######################################

    # Button to reset all settings of the main window
    def click_reset():
        mySV.mmode = int(mySV._data.mtgrid/5)
        var_mmode.set(mySV.mmode)
        mySV.pmode = int(mySV._data.mtoroidal/5)
        var_pmode.set(mySV.pmode)
         
        mySV.cutoff = 1.0
        var_cutoff.set(mySV.cutoff)
        
        mySV.plot_mode = 0
        select_plt.set(0)
    btn_reset = tk.Button(window, text="reset", fg="red", 
                          command=click_reset, height=1, width=10)
    btn_reset.grid(column=12, row=13)

    # Button to quit the main window
    btn_quit = tk.Button(window, text="Quit", fg="red", 
                        command=window.destroy, height=1, width=10)
    btn_quit.grid(column=13, row=13)

    window.mainloop()

    ## test functions

    #myEV.print_test()
    #input("press Enter...")

    #plt.show(block=False)
    #input("press Enter to close plots")

